/* This file is part of the KDE project

   Copyright (C) 2003 Georg Robbers <Georg.Robbers@urz.uni-hd.de>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; version 2
   of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef _ARKPLUGIN_H_
#define _ARKPLUGIN_H_

#include <konq_popupmenu.h>
#include <tdefileitem.h>
#include <tdeconfig.h>

class TDEAction;
class TQSignalMapper;

class ArkMenu : public KonqPopupMenuPlugin {
  TQ_OBJECT
  
public:
    ArkMenu( KonqPopupMenu *, const char *name, const TQStringList & list );
    virtual ~ArkMenu();

public slots:
    void slotCompressAsDefault();
    void slotCompressAs( int pos );
    void slotAddTo( int pos );
    void slotAdd();
    void slotExtractHere();
    void slotExtractToSubfolders();
    void slotExtractTo();
    void slotPrepareCompAsMenu();
    void slotPrepareAddToMenu();

protected:
    void extMimeTypes();
    void compMimeTypes();
    void compressAs( const TQStringList &name, const KURL & compressed );

    void stripExtension( TQString & name );

private:
    TQString m_name, m_ext;
    TQValueList<KURL> m_urlList;
    TQStringList m_urlStringList;
    KURL::List m_archiveList;
    TQStringList m_archiveMimeTypes;
    TQStringList m_extractMimeTypes;
    TQStringList m_extensionList;
    TDEActionMenu * m_compAsMenu;
    TDEActionMenu * m_addToMenu;
    TQSignalMapper * m_compAsMapper;
    TQSignalMapper * m_addToMapper;
    TDEConfig * m_conf;
    TQString m_dir; //contains the currect directory
};

#endif

